<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'custpptype',
    label: '客户类型',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'rulecode',
    label: '预警规则',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'currencycode',
    label: '币种',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'debgbs',
    label: '大额报告笔数',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'debgfs',
    label: '大额报告份数',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'debgje',
    label: '大额报告金额(万元)',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

